program mpigather

  use mpi
  
  implicit none
  
  integer, parameter :: NBUFF = 4

  integer :: i, rank, size, comm, ierr

  integer :: vectortype, resizevectortype
  integer :: intsize
  integer(kind=MPI_ADDRESS_KIND) :: newsize, offset
  
  integer :: sendbuff(NBUFF)
  integer, allocatable :: recvbuff(:)

  comm = MPI_COMM_WORLD

  call MPI_Init(ierr)
  call MPI_Comm_rank(comm, rank, ierr)
  call MPI_Comm_size(comm, size, ierr)

  allocate(recvbuff(size*NBUFF))

  do i = 1, NBUFF
     sendbuff(i) = rank + (i-1)*size
  end do

  recvbuff(:) = -1

  call MPI_Gather(sendbuff, NBUFF, MPI_INT, &
                  recvbuff, NBUFF, MPI_INT, &
                  0, comm, ierr)

  if (rank == 0) then

     write(*,*) 'Result with standard gather'
     write(*,*)
     write(*,fmt='(99(i3,1x))') (recvbuff(i), i = 1, NBUFF*size)

  end if

  call MPI_Finalize(ierr)

end program mpigather
