#include <stdio.h>
#include <mpi.h>

#define NBUFF 4

void main(void)
{
  int i;
  MPI_Comm comm = MPI_COMM_WORLD;
  MPI_Datatype vector, resizevector;
  int rank, size;
  
  MPI_Init(NULL, NULL);
  MPI_Comm_rank(comm, &rank);
  MPI_Comm_size(comm, &size);

  int sendbuff[NBUFF];
  int recvbuff[size*NBUFF];

  for (i=0; i < NBUFF; i++)
    {
      sendbuff[i] = rank+i*size;
    }

  for (i=0; i < NBUFF*size; i++)
    {
      recvbuff[i] = -1;
    }

  MPI_Gather(sendbuff, NBUFF, MPI_INT, recvbuff, NBUFF, MPI_INT, 0, comm);

  if (rank == 0)
    {
      printf("Result with standard gather\n\n");

      for(i=0; i < NBUFF*size; i++)
	{
	  printf("%d ", recvbuff[i]);
	}
      printf("\n");
    }

  MPI_Type_vector(NBUFF, 1, size, MPI_INT, &vector);
  MPI_Type_create_resized(vector, 0, sizeof(int), &resizevector);
  MPI_Type_commit(&resizevector);


  MPI_Gather(sendbuff, NBUFF, MPI_INT, recvbuff, 1, resizevector, 0, comm);

  if (rank == 0)
    {
      printf("\nResult with vector gather\n\n");

      for(i=0; i < NBUFF*size; i++)
	{
	  printf("%d ", recvbuff[i]);
	}
      printf("\n");
    }

  MPI_Finalize();
}
